---
categories: wm stump
title: Howto StumpWM
...

StumpWM est un gestionnaire de fenêtre écrit en Common Lisp qui se veut minimimaliste au niveau visuel, personnalisable à chaud grâce au pouvoir de la programmation fonctionnelle et CL, et concentré à un usage central et total au clavier (dans le même esprit que [ratpoison](https://fr.wikipedia.org/wiki/Ratpoison)).

## Installation

~~~{.bash}
# apt install stumpwm
~~~

## Utilisation de base

Comme tout gestionnaire de fenêtre, à lancer lors du lancement de X.

*Note: il peut être intéressant de mettre la touche **CTRL** à la place de **LOCKS** car celle-ci sera souvent utilisé*

Une fois démarré et utilisable, vous devriez voir un message en haut à droite de l'écran pour vous inviter à commencer à utiliser le gestionnaire de fenêtre en commencant par <Ctrl>+T (^T).

*Note: Tous les messages et autres messages d'informations s'ouvrent en haut à droite de l'écran*

Toutes combinaisons doit être précédées de la combinaison de touches **<Ctrl>+T** <=> ^T :

*Note: doc basé sur stumpwm 0.9.8 - package présent sur Debian Jessie.

## Les premiers pas

*Note: **^X** correspond à la combinaison **^t + ^X** c'est à dire **<ctrl> t** suivis de **<ctrl> X**.
**`X** correspond aussi bien à **^t + ^X** que **^t + X**
**X + <prompt>** correspond à **^t + X** suivis du texte à écrire (ex: nom commande) indiqué en haut à droite dans le prompt*


### Le minimum vital

~~~
^h : afficher l'aide help #^g pour nettoyer l'écran
`c : ouvrir un terminal #/etc/alternatives/x-terminal-emulator
`e : ouvrir emacs #/etc/alternatives/emacs
^! + <prompt> : executer la commande #/bin/sh -c
~~~

*Note: Le prompt se fera aussi comme tous messages en haut à droite de l'écran. Il faudra taper - pour l'exemple **^!** - le nom du programme puis valider avec la touche entrée. L'autocomplétion (avec **TAB**) fonctionne toujours dans le prompt.*


### Gérer la/les fenêtres

~~~
`k : Tuer la fenêtre #<=> kill
^K : Tuer la fenêtre #<=> kill -9
^w : Lister les fenêtres (du groupe)
~~~


### Se déplacer simplement

~~~
o : Fenêtre suivante

~~~


### Gérer les bureaux (groups)

~~~
G : Lister les groupes avec les fenêtres présentes
F* : Choisir le groupe numéro '*'
~~~


### Help++

#### Infos sur les commandes

~~~
^h : message help de base
h + c + <prompt> : avoir info sur une commande
h + k + <prompt> : connaître à quoi correspond le raccourci en question tapé dans le prompt
h + ^h : connaitre les raccourcis disponnible pour l'aide
~~~


### Les petits plus

~~~
`b : faire disparaitre son curseur en bas à droite de l'écran
^g : annuler le raccourci en cours (nettoie aussi les messages si présent - en haut à droite)
v : connaître la version de votre WM
~~~